Shell 编程就像 20 世纪 50 年代的点唱机 . . . --Larry Wall |
在最简单的情况下,脚本只不过是存储在文件中的系统命令列表。至少,这节省了每次调用时重新键入特定命令序列的工作。
示例 2-1. cleanup:一个清理 /var/log 中日志文件的脚本
# Cleanup # Run as root, of course. cd /var/log cat /dev/null > messages cat /dev/null > wtmp echo "Log files cleaned up." |
这里没有什么特别之处,只是一组命令,这些命令同样可以很容易地从控制台或终端窗口的命令行逐个调用。将命令放在脚本中的优势远远不止不必一次又一次地重新键入它们。脚本变成了一个 程序 —— 一个工具 —— 并且可以很容易地针对特定应用程序进行修改或定制。
示例 2-2. cleanup:一个改进的清理脚本
#!/bin/bash # Proper header for a Bash script. # Cleanup, version 2 # Run as root, of course. # Insert code here to print error message and exit if not root. LOG_DIR=/var/log # Variables are better than hard-coded values. cd $LOG_DIR cat /dev/null > messages cat /dev/null > wtmp echo "Logs cleaned up." exit # The right and proper method of "exiting" from a script. # A bare "exit" (no parameter) returns the exit status #+ of the preceding command. |
现在这开始看起来像一个真正的脚本了。但是我们可以更进一步 . . .
示例 2-3. cleanup:上述脚本的增强和通用版本。
#!/bin/bash # Cleanup, version 3 # Warning: # ------- # This script uses quite a number of features that will be explained #+ later on. # By the time you've finished the first half of the book, #+ there should be nothing mysterious about it. LOG_DIR=/var/log ROOT_UID=0 # Only users with $UID 0 have root privileges. LINES=50 # Default number of lines saved. E_XCD=86 # Can't change directory? E_NOTROOT=87 # Non-root exit error. # Run as root, of course. if [ "$UID" -ne "$ROOT_UID" ] then echo "Must be root to run this script." exit $E_NOTROOT fi if [ -n "$1" ] # Test whether command-line argument is present (non-empty). then lines=$1 else lines=$LINES # Default, if not specified on command-line. fi # Stephane Chazelas suggests the following, #+ as a better way of checking command-line arguments, #+ but this is still a bit advanced for this stage of the tutorial. # # E_WRONGARGS=85 # Non-numerical argument (bad argument format). # # case "$1" in # "" ) lines=50;; # *[!0-9]*) echo "Usage: `basename $0` lines-to-cleanup"; # exit $E_WRONGARGS;; # * ) lines=$1;; # esac # #* Skip ahead to "Loops" chapter to decipher all this. cd $LOG_DIR if [ `pwd` != "$LOG_DIR" ] # or if [ "$PWD" != "$LOG_DIR" ] # Not in /var/log? then echo "Can't change to $LOG_DIR." exit $E_XCD fi # Doublecheck if in right directory before messing with log file. # Far more efficient is: # # cd /var/log || { # echo "Cannot change to necessary directory." >&2 # exit $E_XCD; # } tail -n $lines messages > mesg.temp # Save last section of message log file. mv mesg.temp messages # Rename it as system log file. # cat /dev/null > messages #* No longer needed, as the above method is safer. cat /dev/null > wtmp # ': > wtmp' and '> wtmp' have the same effect. echo "Log files cleaned up." # Note that there are other log files in /var/log not affected #+ by this script. exit 0 # A zero return value from the script upon exit indicates success #+ to the shell. |
由于您可能不希望擦除整个系统日志,因此此版本的脚本保留了消息日志的最后一部分。您将不断发现微调以前编写的脚本以提高效率的方法。
脚本开头的 sha-bang ( #!) [1] 告诉您的系统,此文件是一组要馈送到指示的命令解释器的命令。 #! 实际上是一个双字节的 [2] magic number,一个特殊的标记,用于指定文件类型,或者在本例中是一个可执行的 shell 脚本(类型man magic以获取有关这个引人入胜的主题的更多详细信息)。紧随 sha-bang 之后的是 path name。 这是解释脚本中命令的程序的路径,无论它是一个 shell、一种编程语言还是一个实用程序。 然后,这个命令解释器执行脚本中的命令,从顶部(sha-bang 行之后的行)开始,并忽略注释。 [3]
#!/bin/sh #!/bin/bash #!/usr/bin/perl #!/usr/bin/tcl #!/bin/sed -f #!/bin/awk -f |
上面的每个脚本头行都调用不同的命令解释器,无论是/bin/sh,默认 shell(Linux 系统中的 bash)或其他。 [4] 使用#!/bin/sh,大多数商业 UNIX 变体中的默认 Bourne shell,使脚本 可移植 到非 Linux 机器,尽管您 牺牲了 Bash 特定的功能。 但是,该脚本将符合 POSIX [5] sh 标准。
请注意,“sha-bang” 中给出的路径必须正确,否则错误消息 —— 通常是 “Command not found.” —— 将是运行脚本的唯一结果。 [6]
如果脚本仅由一组通用系统命令组成,而不使用内部 shell 指令,则可以省略 #!。 上面的第二个示例需要初始的 #!,因为变量赋值行,lines=50,使用了 shell 特定的结构。 [7] 再次注意#!/bin/sh调用默认的 shell 解释器,默认情况下为/bin/bash在 Linux 机器上。
![]() | 本教程鼓励使用模块化方法来构建脚本。 记下并收集 “boilerplate” 代码片段,这些代码片段可能在未来的脚本中很有用。 最终,您将构建一个相当广泛的漂亮例程库。 例如,以下脚本序言测试脚本是否已使用正确数量的参数调用。
很多时候,您会编写一个执行特定任务的脚本。 本章中的第一个脚本就是一个例子。 稍后,您可能会想到将脚本通用化以执行其他类似的任务。 将字面量(“hard-wired”)常量替换为变量是朝着这个方向迈出的一步,将重复的代码块替换为 函数 也是如此。 |
[1] | 在文献中更常见的是 she-bang 或 sh-bang。 这源于标记 sharp (#) 和 bang (!) 的串联。 | |
[2] | 据称,某些 UNIX 版本(基于 4.2 BSD 的版本)采用四字节的 magic number,需要在 ! 之后留一个空格 ——#! /bin/sh. 根据 Sven Mascheck 的说法,这可能是一个神话。 | |
[3] | shell 脚本中的 #! 行将是命令解释器(sh 或 bash)看到的第一个内容。 由于此行以 # 开头,因此当命令解释器最终执行脚本时,它将被正确地解释为注释。 该行已经达到了它的目的 —— 调用命令解释器。 事实上,如果脚本包含一个额外的 #! 行,那么 bash 会将其解释为注释。
| |
[4] | 这允许一些巧妙的技巧。
另外,尝试启动一个README文件,使用#!/bin/more,并使其可执行。 结果是一个自列文档文件。 (使用 cat 的 here document 可能是更好的选择 —— 请参阅 示例 19-3)。 | |
[5] | Portable Operating System Interface,旨在标准化类 UNIX 操作系统。 POSIX 规范在 Open Group 网站 上列出。 | |
[6] | 为了避免这种可能性,脚本可能以 #!/bin/env bash sha-bang 行开头。 这在 bash 未位于以下位置的 UNIX 机器上可能很有用/bin | |
[7] | 如果 Bash 是您的默认 shell,那么 #! 在脚本的开头不是必需的。 但是,如果从不同的 shell(例如 tcsh)启动脚本,那么您将需要 #!。 |